SystemOrganization addCategory: #FuelPackaging!

!MCVersionReader methodsFor: '*FuelPackaging' stamp: 'pre 1/16/2013 14:03'!
basicVersion
	^ MCVersion
		package: self package
		info: self info
		snapshot: self snapshot
		dependencies: self dependencies
		binary: self binary! !

!MCVersionReader methodsFor: '*FuelPackaging' stamp: 'pre 1/16/2013 14:25'!
binary
	
	^ self loadBinary! !

!MCVersionReader methodsFor: '*FuelPackaging' stamp: 'pre 1/16/2013 14:11'!
loadBinary
	self subclassResponsibility! !

!MCWorkingCopy methodsFor: '*FuelPackaging' stamp: 'pre 1/17/2013 10:28'!
wipe

	MCPackageLoader unloadPackage: self package.
	! !

!MCVersion class methodsFor: '*FuelPackaging' stamp: 'pre 1/16/2013 14:03'!
package: t1 info: t2 snapshot: t3 dependencies: t4 binary: fuelPackage
	^ self new
		initializeWithPackage: t1
		info: t2
		snapshot: t3
		dependencies: t4
		binary: fuelPackage! !

!MCVersion methodsFor: '*FuelPackaging' stamp: 'pre 1/16/2013 14:05'!
binary

	^ binary! !

!MCVersion methodsFor: '*FuelPackaging' stamp: 'pre 1/16/2013 14:05'!
binary: anObject

	binary := anObject! !

!MCVersion methodsFor: '*FuelPackaging' stamp: 'pre 1/16/2013 14:05'!
initializeWithPackage: aPackage info: aVersionInfo snapshot: aSnapshot dependencies: aCollection binary: fuelPackage
	self
		setPackage: aPackage
		info: aVersionInfo
		snapshot: aSnapshot
		dependencies: aCollection.
	self binary: fuelPackage.
	self addToCache! !

!MCVersion methodsFor: '*FuelPackaging' stamp: 'pre 1/17/2013 11:05'!
load
	(self binary notNil and: [self binary materialize]) ifTrue: [
		self workingCopy loaded: self. ] 
	ifFalse: [
		"fallback"
		MCVersionLoader loadVersion: self ] 
	! !

!MCPackage methodsFor: '*FuelPackaging' stamp: 'pre 1/17/2013 10:29'!
wipe
	^ self workingCopy wipe! !

!MCMczWriter methodsFor: '*FuelPackaging' stamp: 'pre 1/16/2013 13:45'!
serializeBinaryModule: aMCVersion 
	| aPackage |
	aPackage := FuelPackage newFromPackageNamed: aMCVersion package name.
	^ aPackage serialize contents! !

!MCMczWriter methodsFor: '*FuelPackaging' stamp: 'JH 1/16/2013 11:49'!
writeBinaryModule: aMCVersion

	self
		addString: (self serializeBinaryModule: aMCVersion)
		at: 'binaryModule.bin'.! !

!MCMczWriter methodsFor: '*FuelPackaging' stamp: 'JH 1/16/2013 12:10'!
writeVersion: t1 
	self writeFormat.
	self writePackage: t1 package.
	self writeVersionInfo: t1 info.
	self writeDefinitions: t1.
	t1 dependencies
		do: [:t2 | self writeVersionDependency: t2].
	self writeBinaryModule: t1! !

!MCMczReader methodsFor: '*FuelPackaging' stamp: 'pre 1/16/2013 17:01'!
loadBinary

	(self zip memberNamed: 'binaryModule.bin') 
		ifNotNil: [:file | ^ FuelPackage newFromStream: (file contentStream) 
										named: self package name  ]
				! !

Object subclass: #FuelPackage
	instanceVariableNames: 'packageName sourceStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelPackaging'!

!FuelPackage class methodsFor: 'as yet unclassified' stamp: 'pre 1/16/2013 13:36'!
newFromPackageNamed: packageName

	| p |
	p := self new.
	p packageName: packageName.
	^p! !

!FuelPackage class methodsFor: 'as yet unclassified' stamp: 'rms 1/16/2013 15:10'!
newFromStream: aStream named: packageName

	| p |
	p := self new.
	p sourceStream: aStream;
	   packageName: packageName.
	^p! !

!FuelPackage methodsFor: 'as yet unclassified' stamp: 'pre 1/17/2013 10:37'!
handleLoadedPackages

	(MCPackage named: self packageName) wipe.
	ClassOrganizer cleanUp: true.! !

!FuelPackage methodsFor: 'as yet unclassified' stamp: 'pre 1/16/2013 17:27'!
materialize

	Transcript show: 'Materializing ' , self packageName , Character cr.
	self handleLoadedPackages.
	self sourceStream binary.
	[ FLPackageLoader new loadFrom: self sourceStream copy. ]
		on: Error
		do: [ :er |
			Transcript show: 'Error Materializing: ' , er description, Character cr.
			^false ].
	^ true
! !

!FuelPackage methodsFor: 'accessing' stamp: 'pre 1/16/2013 13:36'!
packageName

	^ packageName! !

!FuelPackage methodsFor: 'accessing' stamp: 'pre 1/16/2013 13:36'!
packageName: anObject

	packageName := anObject! !

!FuelPackage methodsFor: 'as yet unclassified' stamp: 'pre 1/16/2013 14:22'!
serialize

	| aStream |
	aStream := RWBinaryOrTextStream on: String new.
	aStream binary.
      FLPackageStore new storePackageNamed: self packageName on: aStream.
	^ aStream
	! !

!FuelPackage methodsFor: 'accessing' stamp: 'rms 1/16/2013 13:59'!
sourceStream

	^ sourceStream! !

!FuelPackage methodsFor: 'accessing' stamp: 'rms 1/16/2013 13:59'!
sourceStream: anObject

	sourceStream := anObject! !
